## mingw-w64-gammaray-3.2.2-1.src.tar.zst

=== tests/CMakeLists.txt ===
# This file is part of GammaRay, the Qt application inspection and manipulation tool.
#
# SPDX-FileCopyrightText: 2011 Klarälvdalens Datakonsult AB, a KDAB Group company <info@kdab.com>
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Contact KDAB at <info@kdab.com> for commercial licensing options.
#

# keep test output locally, in the multibuild case
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${LIB_INSTALL_DIR})

configure_file(gammaray-test-config.h.in ${CMAKE_CURRENT_BINARY_DIR}/gammaray-test-config.h)

# create intermediate modeltestobj object files which unit tests can use
add_library(
    modeltestobj OBJECT
)

# create intermediate test_helpers_obj object files which unit tests can use
add_library(
    test_helpers_obj OBJECT
    testhelpers.cpp
)
set_target_properties(test_helpers_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_features(test_helpers_obj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
target_compile_definitions(
    test_helpers_obj PRIVATE $<TARGET_PROPERTY:Qt${QtCore_VERSION_MAJOR}::Core,INTERFACE_COMPILE_DEFINITIONS>
                             $<TARGET_PROPERTY:Qt${QtTest_VERSION_MAJOR}::Test,INTERFACE_COMPILE_DEFINITIONS>
) # for -DQT_NAMESPACE=...
target_include_directories(
    test_helpers_obj
    PUBLIC $<TARGET_PROPERTY:Qt${QtCore_VERSION_MAJOR}::Core,INTERFACE_INCLUDE_DIRECTORIES>
           $<TARGET_PROPERTY:Qt${QtTest_VERSION_MAJOR}::Test,INTERFACE_INCLUDE_DIRECTORIES>
)

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    # create intermediate base_probe_test_obj object files which unit tests can use
    add_library(base_probe_test_obj OBJECT baseprobetest.h)
    set_target_properties(base_probe_test_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
    target_compile_features(base_probe_test_obj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
    target_include_directories(
        base_probe_test_obj PUBLIC $<TARGET_PROPERTY:gammaray_core,INTERFACE_INCLUDE_DIRECTORIES>
                                   $<TARGET_PROPERTY:gammaray_common,INTERFACE_INCLUDE_DIRECTORIES>
    )
    target_compile_definitions(
        base_probe_test_obj PRIVATE $<TARGET_PROPERTY:Qt${QtCore_VERSION_MAJOR}::Core,INTERFACE_COMPILE_DEFINITIONS>
                                    $<TARGET_PROPERTY:Qt${QtTest_VERSION_MAJOR}::Test,INTERFACE_COMPILE_DEFINITIONS>
    ) # for -DQT_NAMESPACE=...
    target_include_directories(
        base_probe_test_obj PUBLIC $<TARGET_PROPERTY:Qt${QtCore_VERSION_MAJOR}::Core,INTERFACE_INCLUDE_DIRECTORIES>
                                   $<TARGET_PROPERTY:Qt${QtTest_VERSION_MAJOR}::Test,INTERFACE_INCLUDE_DIRECTORIES>
    )

    if(TARGET Qt::Quick)
        # create intermediate base_quick_test_obj object files which unit tests can use
        add_library(base_quick_test_obj OBJECT basequicktest.h)
        set_target_properties(base_quick_test_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
        target_compile_features(base_quick_test_obj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
        target_compile_definitions(
            base_quick_test_obj
            PRIVATE $<TARGET_PROPERTY:Qt${QtCore_VERSION_MAJOR}::Core,INTERFACE_COMPILE_DEFINITIONS>
                    $<TARGET_PROPERTY:Qt${QtTest_VERSION_MAJOR}::Test,INTERFACE_COMPILE_DEFINITIONS>
                    $<TARGET_PROPERTY:Qt${QtQuick_VERSION_MAJOR}::Quick,INTERFACE_COMPILE_DEFINITIONS>
        ) # for -DQT_NAMESPACE=...
        target_include_directories(
            base_quick_test_obj PUBLIC $<TARGET_PROPERTY:base_probe_test_obj,INTERFACE_INCLUDE_DIRECTORIES>
        )
        target_include_directories(
            base_quick_test_obj
            PUBLIC $<TARGET_PROPERTY:Qt${QtQuick_VERSION_MAJOR}::Quick,INTERFACE_INCLUDE_DIRECTORIES>
        )
    endif()
endif()

add_subdirectory(shared)
add_subdirectory(manual)
add_subdirectory(targets)

# plain unit tests
function(gammaray_add_test _name)
    add_executable(${_name} ${ARGN} $<TARGET_OBJECTS:test_helpers_obj>)
    gammaray_set_rpath(${_name} ${BIN_INSTALL_DIR})
    target_link_libraries(${_name} Qt::Test)
    add_test(NAME ${_name} COMMAND ${_name})
endfunction()

# unit tests requiring probe injection
function(gammaray_add_probe_test _name)
    add_executable(
        ${_name} ${ARGN} $<TARGET_OBJECTS:gammaray_probe_obj> $<TARGET_OBJECTS:test_helpers_obj>
                 $<TARGET_OBJECTS:base_probe_test_obj>
    )
    gammaray_set_rpath(${_name} ${BIN_INSTALL_DIR})
    target_link_libraries(${_name} $<TARGET_PROPERTY:gammaray_probe,LINK_LIBRARIES> Qt::Test)
    add_test(NAME ${_name} COMMAND ${_name})
endfunction()

# unit tests requiring quick and probe injection
function(gammaray_add_quick_test _name)
    add_executable(
        ${_name}
        ${ARGN}
        $<TARGET_OBJECTS:gammaray_probe_obj>
        $<TARGET_OBJECTS:test_helpers_obj>
        $<TARGET_OBJECTS:base_probe_test_obj>
        $<TARGET_OBJECTS:base_quick_test_obj>
    )
    gammaray_set_rpath(${_name} ${BIN_INSTALL_DIR})
    target_link_libraries(${_name} $<TARGET_PROPERTY:gammaray_probe,LINK_LIBRARIES> Qt::Test)
    add_test(NAME ${_name} COMMAND ${_name})
endfunction()

### BENCH SUITE

if(TARGET Qt::Widgets)
    add_executable(benchsuite benchsuite.cpp)
    gammaray_set_rpath(benchsuite ${BIN_INSTALL_DIR})

    target_link_libraries(
        benchsuite
        Qt::Core
        Qt::Gui
        Qt::Widgets
        Qt::Test
        gammaray_common
        gammaray_core
    )

    #
    # Full-scale injection tests
    #
    add_executable(connectiontest test_connections.cpp)
    gammaray_set_rpath(connectiontest ${BIN_INSTALL_DIR})

    target_link_libraries(
        connectiontest
        Qt::Core
        Qt::Gui
        Qt::Widgets
        Qt::Test
    )

endif()

add_executable(
    attachhelper
    attachhelper.cpp attachhelper.h
)
gammaray_set_rpath(attachhelper ${BIN_INSTALL_DIR})

target_link_libraries(
    attachhelper Qt::Core
)

if(UNIX)
    find_program(GDB_EXECUTABLE gdb)
    find_program(LLDB_EXECUTABLE lldb)
endif()

set(INJECTOR_TYPES)
if(UNIX)
    list(APPEND INJECTOR_TYPES preload style)

    if(GDB_EXECUTABLE)
        list(APPEND INJECTOR_TYPES gdb)
    endif()
    if(LLDB_EXECUTABLE)
        list(APPEND INJECTOR_TYPES lldb)
    endif()
elseif(WIN32)
    list(APPEND INJECTOR_TYPES windll style)
endif()

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    # No probes are available in client only build
    foreach(injectorType ${INJECTOR_TYPES})
        add_test(
            connectiontest-${injectorType}
            ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray
            --inprocess
            --listen
            tcp://127.0.0.1
            -unittest
            -i
            ${injectorType}
            ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
        )
        add_test(
            connectiontest-${injectorType}-filter
            ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray
            --inprocess
            -unittest
            --listen
            tcp://127.0.0.1
            -filtertest
            -i
            ${injectorType}
            ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
        )
        set_tests_properties(connectiontest-${injectorType}-filter PROPERTIES ENVIRONMENT GAMMARAY_TEST_FILTER=1)
    endforeach()
endif()

#
# common and core unit tests
#
gammaray_add_test(multisignalmappertest multisignalmappertest.cpp ../core/multisignalmapper.cpp)
target_link_libraries(
    multisignalmappertest Qt::Gui
)

gammaray_add_test(sourcelocationtest sourcelocationtest.cpp)
target_link_libraries(
    sourcelocationtest Qt::Gui gammaray_common
)

gammaray_add_test(selflocatortest selflocatortest.cpp)
target_link_libraries(
    selflocatortest Qt::Gui gammaray_common ${CMAKE_DL_LIBS}
)

gammaray_add_test(executiontest executiontest.cpp)
target_link_libraries(
    executiontest Qt::Gui gammaray_core
)

gammaray_add_test(metaobjecttest metaobjecttest.cpp)
target_link_libraries(
    metaobjecttest Qt::CorePrivate gammaray_core
)

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    gammaray_add_probe_test(problemreportertest problemreportertest.cpp $<TARGET_OBJECTS:modeltestobj>)
    target_link_libraries(problemreportertest gammaray_core)
    if(TARGET Qt::Qml)
        target_link_libraries(problemreportertest Qt::Qml)
    endif()
    if(TARGET Qt::Widgets)
        target_link_libraries(problemreportertest Qt::Widgets)
    endif()
endif()

gammaray_add_test(objectinstancetest objectinstancetest.cpp)
target_link_libraries(
    objectinstancetest gammaray_core
)

gammaray_add_test(propertysyncertest propertysyncertest.cpp)
target_link_libraries(
    propertysyncertest gammaray_common Qt::Gui
)

gammaray_add_test(propertyadaptortest propertyadaptortest.cpp)
target_link_libraries(
    propertyadaptortest
    gammaray_core
    Qt::Gui
    Qt::CorePrivate
    gammaray_shared_test_data
)

if(HAVE_QT_WIDGETS)
    gammaray_add_test(enumpropertytest enumpropertytest.cpp)
    target_link_libraries(enumpropertytest gammaray_core Qt::Gui Qt::Widgets)
endif()

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    gammaray_add_probe_test(propertymodeltest propertymodeltest.cpp $<TARGET_OBJECTS:modeltestobj>)
    target_link_libraries(propertymodeltest gammaray_core gammaray_shared_test_data)
endif()

gammaray_add_test(qmetaobjectvalidatortest qmetaobjectvalidatortest.cpp)
target_link_libraries(
    qmetaobjectvalidatortest Qt::Gui Qt::CorePrivate gammaray_core
)

if(GAMMARAY_BUILD_UI)
    gammaray_add_test(
        metatypemodeltest
        metatypemodeltest.cpp
        ${CMAKE_SOURCE_DIR}/core/metaobjectregistry.cpp
        ${CMAKE_SOURCE_DIR}/core/tools/metatypebrowser/metatypesmodel.cpp
        ${CMAKE_SOURCE_DIR}/ui/tools/metatypebrowser/metatypesclientmodel.cpp
        $<TARGET_OBJECTS:modeltestobj>
    )
    target_link_libraries(
        metatypemodeltest
        gammaray_core
        Qt::Gui
        Qt::Widgets
        Qt::CorePrivate
    )
endif()

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    gammaray_add_probe_test(signalspycallbacktest signalspycallbacktest.cpp)
    target_link_libraries(signalspycallbacktest gammaray_core)
    gammaray_add_probe_test(integrationtest integrationtest.cpp)
    target_link_libraries(integrationtest gammaray_core)
endif()

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    gammaray_add_probe_test(multithreadingtest multithreadingtest.cpp)
    target_link_libraries(multithreadingtest gammaray_core)

    if(GAMMARAY_BUILD_UI)
        gammaray_add_probe_test(
            methodmodeltest
            methodmodeltest.cpp
            ${CMAKE_SOURCE_DIR}/core/objectmethodmodel.cpp
            ${CMAKE_SOURCE_DIR}/core/qmetaobjectvalidator.cpp
            ${CMAKE_SOURCE_DIR}/core/metaobjectregistry.cpp
            ${CMAKE_SOURCE_DIR}/ui/tools/objectinspector/clientmethodmodel.cpp
            $<TARGET_OBJECTS:modeltestobj>
        )
        target_link_libraries(
            methodmodeltest
            gammaray_core
            Qt::Gui
            Qt::Widgets
            Qt::CorePrivate
        )
    endif()
endif()

#
# ui unit tests
#
if(GAMMARAY_BUILD_UI)
    gammaray_add_test(propertybindertest propertybindertest.cpp)
    target_link_libraries(propertybindertest gammaray_ui)

    if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
        gammaray_add_probe_test(
            metaobjecttreemodeltest metaobjecttreemodeltest.cpp
            ${CMAKE_SOURCE_DIR}/ui/tools/metaobjectbrowser/metaobjecttreeclientproxymodel.cpp
            $<TARGET_OBJECTS:modeltestobj>
        )
        target_link_libraries(metaobjecttreemodeltest gammaray_core gammaray_ui Qt::Gui)

        gammaray_add_probe_test(
            toolmanagertest toolmanagertest.cpp ../common/toolmanagerinterface.cpp $<TARGET_OBJECTS:modeltestobj>
        )
        target_link_libraries(toolmanagertest gammaray_core gammaray_ui Qt::Network)
    endif()
endif()

#
# launcher unit tests
#
add_executable(
    sleep
    sleep.cpp
)
target_link_libraries(
    sleep Qt::Core
)

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=gammaray
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=3.2.2
pkgrel=1
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
pkgdesc="A tool for examining the internals of a Qt application and to some extent also manipulate it"
url="https://www.kdab.com/gammaray/"
msys2_repository_url="https://github.com/KDAB/GammaRay"
msys2_references=(
  'archlinux: gammaray'
)
license=('spdx:GPL-2.0-or-later')
provides=("${MINGW_PACKAGE_PREFIX}-${_realname}-qt5")
replaces=("${MINGW_PACKAGE_PREFIX}-${_realname}-qt5")
conflicts=("${MINGW_PACKAGE_PREFIX}-${_realname}-qt5")
depends=("${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-dlfcn")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-extra-cmake-modules"
             "${MINGW_PACKAGE_PREFIX}-qt6-3d"
             "${MINGW_PACKAGE_PREFIX}-qt6-connectivity"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-location"
             "${MINGW_PACKAGE_PREFIX}-qt6-positioning"
             "${MINGW_PACKAGE_PREFIX}-qt6-scxml"
             "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
             "${MINGW_PACKAGE_PREFIX}-qt6-svg"
             "${MINGW_PACKAGE_PREFIX}-qt6-tools"
             "${MINGW_PACKAGE_PREFIX}-kcoreaddons-qt5"
             "${MINGW_PACKAGE_PREFIX}-kdstatemachineeditor-qt5"
             "${MINGW_PACKAGE_PREFIX}-qt5-3d"
             "${MINGW_PACKAGE_PREFIX}-qt5-connectivity"
             "${MINGW_PACKAGE_PREFIX}-qt5-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt5-gamepad"
             "${MINGW_PACKAGE_PREFIX}-qt5-location"
             "${MINGW_PACKAGE_PREFIX}-qt5-script"
             "${MINGW_PACKAGE_PREFIX}-qt5-scxml"
             "${MINGW_PACKAGE_PREFIX}-qt5-svg"
             "${MINGW_PACKAGE_PREFIX}-qt5-tools"
             "${MINGW_PACKAGE_PREFIX}-syntax-highlighting-qt5"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-glslang")
optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-3d: 3D plugins"
            "${MINGW_PACKAGE_PREFIX}-qt6-declarative: Quick/Qml and positioning plugins"
            "${MINGW_PACKAGE_PREFIX}-qt6-scxml: state machine viewer plugin"
            "${MINGW_PACKAGE_PREFIX}-qt6-connectivity: bluetooth plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-positioning: positioning plugin"
            "${MINGW_PACKAGE_PREFIX}-qt6-svg: Widget Export actions plugin"
            "${MINGW_PACKAGE_PREFIX}-qt6-tools: Widget Export actions plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-3d: Qt5 3D plugins"
            "${MINGW_PACKAGE_PREFIX}-qt5-base: Qt5 applications support"
            "${MINGW_PACKAGE_PREFIX}-qt5-declarative: Qt5 Quick/Qml and positioning plugins"
            "${MINGW_PACKAGE_PREFIX}-qt5-scxml: Qt5 state machine viewer plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-connectivity: Qt5 bluetooth plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-script: Qt5 script engine debugger plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-location: Qt5 positioning plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-svg: Qt5 Widget Export actions plugin"
            "${MINGW_PACKAGE_PREFIX}-qt5-tools: Qt5 Widget Export actions plugin"
            "${MINGW_PACKAGE_PREFIX}-kcoreaddons-qt5: KJob tracker plugin"
            "${MINGW_PACKAGE_PREFIX}-kdstatemachineeditor-qt5: ")
source=(${msys2_repository_url}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz
        003-win32-not-elf.patch
        004-files-layout.patch
        005-fix-dll-naming.patch)
sha256sums=('18830a83ca8ba8e6e07d78a88d933c2666eda4b26d3cbdc97e06914f5e92388c'
            'b13e2caa213d0b83a37c72e57bb5dc6e1d7e3d06d3f3031ad8931df3059cd9c0'
            '5c7e44e3fa6e914e369c2149fe9ca4b9e133f6753c7c6539cef66c9aeac5da21'
            '1d4ebacca418f8f1c9df0c4c438742e63d5d372d37d1605ecf9b478b098155eb')
validpgpkeys=(E86C000370B1B9E2A9191AD53DBFB6882C9358FB) # KDAB Products <info@kdab.com>

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd ${_realname}-${pkgver}
  apply_patch_with_msg \
    003-win32-not-elf.patch \
    004-files-layout.patch \
    005-fix-dll-naming.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    _extra_config+=("-DSTACK_DETAILS_BFD=ON")
  else
    _extra_config+=("-DSTACK_DETAILS_BFD=OFF")
  fi

  for _qt_ver in 5 6; do
    if [[ ${_qt_ver} == 5 ]]; then
      _include_dir=include
    else
      _include_dir=include/qt6
    fi
    MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=;-DECM_MKSPECS_INSTALL_DIR=;-DPLUGIN_INSTALL_DIR=;" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -G "Ninja" \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_INSTALL_OLDINCLUDEDIR=${MINGW_PREFIX}/${_include_dir} \
      -DTRANSLATION_INSTALL_DIR=${MINGW_PREFIX}/share/qt${_qt_ver}/translations \
      -DPLUGIN_INSTALL_DIR=${MINGW_PREFIX}/share/qt${_qt_ver}/plugins/gammaray \
      -DECM_MKSPECS_INSTALL_DIR=${MINGW_PREFIX}/share/qt${_qt_ver}/mkspecs/modules \
      -DGAMMARAY_INSTALL_QT_LAYOUT=ON \
      -DGAMMARAY_MULTI_BUILD=FALSE \
      -DGAMMARAY_WITH_KDSME=OFF \
      -DSTACK_DETAILS_AUTO_DETECT=OFF \
      -DMINGW_MSVCR_LIBRARY="" \
      -DQT_VERSION_MAJOR=${_qt_ver} \
      "${_extra_config[@]}" \
      -S ${_realname}-${pkgver} \
      -B build-${MSYSTEM}-qt${_qt_ver}

    ${MINGW_PREFIX}/bin/cmake.exe --build build-${MSYSTEM}-qt${_qt_ver}
  done
}

package() {
  for _qt_ver in 5 6; do
    DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install build-${MSYSTEM}-qt${_qt_ver}
  done

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE.txt "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
